<template>
    <div class="recentNewUser admin_page">
		<div class="admin_table_search">
			<div class="admin_state">
			
				<div class="admin_state_item">
					<span>State Time:</span>
					<a-range-picker
						style="width:280px"
						class="range_picker"
						v-model:value="rangePickerValue"
						:allowClear="false"
						:placeholder="[
							$t('HistoryPage.StartDate'),
							$t('HistoryPage.EndDate'),
						]"
						valueFormat="YYYY-MM-DD"
					>
						<template #suffixIcon>
							<span
								class="icon iconfont range_picker_icon icon-rili"
							></span>
						</template>
					</a-range-picker>
				</div>
				<div class="admin_state_item">
					<span>Type:</span>
					<a-select v-model:value="userType" size="large" style="width:280px" optionFilterProp="label" :options="state" placeholder="Please select" allowClear show-search></a-select>
				</div>
			</div>
			<div class="admin_search">
				<div class="admin_search_item" @click="searchHistoryList">Search</div>
			</div>
			<div class="admin_state_list">
				<div class="admin_state_list_item" @click="lastGeTrialList('year')">Last year</div>
				<div class="admin_state_list_item" @click="lastGeTrialList('month')">Last month</div>
				<div class="admin_state_list_item" @click="lastGeTrialList('week')">Last week</div>
			</div>
		</div>

		<div class="admin_table_content" ref="historyTable">
			<a-table
				@resizeColumn="handleResizeColumn"
				:loading="tableLoading"
				:columns="columns"
				:data-source="dataList"
				:scroll="{ y: historyTableHeight }"
				@change="changePage"
				:pagination="{
					showSizeChanger: true,
					current: currentPage,
					pageSize: pageSize,
					total: total,
					showQuickJumper: true,
					bordered: false,
				}"
			>
			</a-table>
		</div>
    </div>
</template>
<script lang="ts">
import { defineComponent, ref, createVNode, computed, reactive, toRefs, onMounted } from "vue";
import { formatTime } from "@/tool/util";
import { Https } from "@/tool/https";
export default defineComponent({
    components: {
    },
    setup() {
        let filter:any =  reactive({
			dataList:[],
			tableLoading:false,
		})
		let filterData:any = reactive({
			rangePickerValue:[],
			currentPage: 1,
            pageSize: 10,
            total: 0,
			userType:'',
		})
		let state:any = ref([
			{
				label:'all',
				value:'',
			},
			{
				label:'visitor',
				value:'0',
			},
			{
				label:'yearly',
				value:'1',
			},
			{
				label:'monthly',
				value:'2',
			},
			{
				label:'trial',
				value:'3',
			},
		])
        let renameData: any = ref({}); //修改名字选中的数据
        const columns: any = computed(() => {
            return [
				{
                    title: 'User Id',
                    align: "center",
                    ellipsis: true,
                    dataIndex: "id",
                    key: "id",
					fixed: 'left' 
                },
                {
                    title: 'Email',
                    align: "center",
                    ellipsis: true,
                    dataIndex: "userEmail",
                    key: "userEmail",
                },
				{
                    title: 'User Name',
                    align: "center",
                    ellipsis: 200,
                    dataIndex: "userName",
                    key: "userName",
                    // customRender: (record: any) => {
                    //     let time = formatTime(
                    //         record.text / 1000,
                    //         "YYYY-MM-DD hh:mm:ss"
                    //     );
                    //     return time;
                    // },
                },
				{
                    title: 'language',
                    align: "center",
                    ellipsis: true,
                    dataIndex: "language",
                    key: "language",
                },
                {
                    title: 'Valid Start Time',
                    align: "center",
                    ellipsis: true,
                    dataIndex: "validstartTime",
                    key: "validstartTime",
                },
				{
                    title: 'Valid End Time',
                    align: "center",
                    ellipsis: true,
                    dataIndex: "validendTime",
                    key: "validendTime",
                },
				{
                    title: 'Country',
                    align: "center",
                    ellipsis: true,
                    dataIndex: "country",
                    key: "country",
                },
				{
                    title: 'Create Date',
                    align: "center",
                    ellipsis: true,
                    dataIndex: "createDate",
                    key: "createDate",
                },
				{
                    title: 'Is Beginner',
                    align: "center",
                    ellipsis: true,
                    dataIndex: "isBeginner",
                    key: "isBeginner",
					customRender: (record: any) => {
                        let str
						if(record.value == 1){
							str ='Yes'
						}else{
							str ='No'
						}
                        return str;
                    },
                },
				{
                    title: 'Machine Room Ip',
                    align: "center",
                    ellipsis: true,
                    dataIndex: "browserIdentifiers",
                    key: "browserIdentifiers",
                },
				{
                    title: 'Credits',
                    align: "center",
                    ellipsis: true,
					// width: 150,
					// minWidth: 100,
        			// maxWidth: 200,
					// resizable: true,
                    dataIndex: "credits",
                    key: "credits",
                },
				{
                    title: 'User Type',
                    align: "center",
                    ellipsis: true,
					// width: 150,
					// minWidth: 100,
        			// maxWidth: 200,
					// resizable: true,
                    dataIndex: "systemUser",
                    key: "systemUser",
					customRender: (record: any) => {
                        let str
						if(record.value == 0){
							str ='visitor'
						}else if(record.value == 1){
							str ='yearly'
						}else if(record.value == 2){
							str ='monthly'
						}else if(record.value == 3){
							str ='trial'
						}else if(record.value == 4){
							str ='userInEvent'
						}
                        return str;
                    },
                },
				
            ];
        });
		//改变页码
		let changePage = (e: any) => {
            filterData.currentPage = e.current;
            filterData.pageSize = e.pageSize;
            // gettrialList();
        }

        //查询列表
        let searchHistoryList = ()=> {
            filterData.currentPage = 1;
            gettrialList();
        }

		//获取列表
        let gettrialList = () =>{
			filter.tableLoading = true
			let startDate: any = filterData.rangePickerValue?.[0]
                ? filterData.rangePickerValue[0]+' '+'00:00:00'
                : "";
            let endDate: any = filterData.rangePickerValue?.[1]
                ? filterData.rangePickerValue[1]+' '+'00:00:00'
                : "";
			let data = {
				endTime:endDate,
				startTime:startDate,
				size:filterData.pageSize,
				page:filterData.currentPage,
				userType:filterData.userType,
			}
			Https.axiosGet(Https.httpUrls.recentNewUser,{params:data}).then((rv: any) => {
				if (rv) {
					// this.dataList = rv
					filter.dataList = rv.records
					filterData.total = rv.total
					filter.tableLoading = false
					
					// this.workspaceItem.position = this.singleTypeList[0].label
				}
			})
        }
		let lastGeTrialList = (str:string)=>{
			let currentDate = new Date();
			let currentTimestamp = Math.floor(currentDate.getTime()  / 1000);
			// 计算30天前的时间戳
			let thirtyDaysAgoTimestamp
			if(str == 'year'){
				thirtyDaysAgoTimestamp = currentTimestamp - (360 * 24 * 60 * 60);
			}else if(str == 'month'){
				thirtyDaysAgoTimestamp = currentTimestamp - (30 * 24 * 60 * 60);
			}else if(str == 'week'){
				thirtyDaysAgoTimestamp = currentTimestamp - (7 * 24 * 60 * 60);
			}
			filterData.rangePickerValue[0] = formatTime(thirtyDaysAgoTimestamp,'YYYY-MM-DD')
			filterData.rangePickerValue[1] = formatTime(currentTimestamp,'YYYY-MM-DD')
			gettrialList();
		}
		onMounted(()=>{
			lastGeTrialList('month')
		})
        return {
			...toRefs(filter),
			...toRefs(filterData),
			state,
            columns,
            renameData,
			changePage,
			searchHistoryList,
			lastGeTrialList,
			gettrialList,
        };
    },
    data() {
        return {
            
            historyTableHeight: 0,
			handleResizeColumn: (w:any, col:any) => {
				col.width = w;
			},
        };
    },
    mounted() {
        let historyTable: any = this.$refs.historyTable;
        this.historyTableHeight = historyTable.clientHeight - 200;
    },
    methods: {
        
    },
});
</script>
